import { readdir as q, readFile as T, writeFile as M } from "fs/promises";
import { existsSync as C, mkdirSync as D } from "fs";
import { normalize as A, join as K, extname as F } from "path";
/**
 * @license
 * Qwik Speak
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/robisim74/qwik-speak/blob/main/LICENSE
 */
function Q(s, e = 0) {
  const a = [], u = [], f = [];
  let c = "", o = e;
  const p = (r) => (e = o, { type: r, value: w(), position: { start: e, end: o } }), x = (r) => {
    r.value = w(), r.position.start = e, r.position.end = o;
  }, v = () => s[++o], E = () => o < s.length - 1 ? s[o + 1] : "", P = () => o > 0 ? s[o - 1] : "", w = () => s.substring(e, o + 1), j = (r) => /["'`0-9+-]/.test(r), S = (r) => /[a-zA-Z_$]/.test(r), b = (r) => /[(){},:;.[\]?!=<>]/.test(r), g = (r) => /\//.test(r) && /\*/.test(E()), $ = (r, l) => {
    if (!l)
      l = p("Literal"), a.push(l);
    else {
      if (f.length === 0 && !/[0-9.]/.test(r))
        return y(r);
      x(l);
    }
    return f.length === 0 && /["'`]/.test(r) ? f.push(r) : f.length > 0 && f[f.length - 1] === r && (/\\/.test(P()) || f.pop()), $(v(), l);
  }, t = (r, l) => {
    if (!l)
      c = r, l = p("Identifier"), a.push(l);
    else if (/[0-9a-zA-Z_$. ]/.test(r))
      c += r, (c == "null" || c == "undefined" || c == "true" || c == "false" || c == "void 0") && (l.type = "Literal"), x(l);
    else
      return y(r);
    return t(v(), l);
  }, n = (r, l) => (l = p("Punctuator"), a.push(l), /\(/.test(r) ? u.push(r) : /\)/.test(r) && u.pop(), y(v())), i = (r) => /\//.test(r) && /\*/.test(P()) ? y(r) : i(v()), d = () => a[a.length - 1]?.type === "Punctuator" && u.length === 0 || o === s.length, y = (r = s[o]) => d() ? a : j(r) ? $(r) : S(r) ? t(r) : b(r) ? n(r) : g(r) ? i(r) : y(v());
  return y();
}
function W(s, e, a) {
  let u, f = 0;
  const c = [], o = () => f < s.length - 1 ? s[f + 1] : { type: "", value: "", position: { start: 0, end: 0 } }, p = () => s[++f], x = () => s[s.length - 1], v = (t) => t.replace(/^["'`]|["'`]$/g, ""), E = (t) => (u.arguments.push({ type: "Literal", value: v(t.value) }), g(p())), P = (t) => (u.arguments.push({ type: "Identifier", value: t.value }), g(p())), w = (t, n, i) => (i || (i = {
    type: "Property",
    key: { type: "Identifier", value: t.value },
    value: { type: "Literal", value: "" }
  }, n.push(i)), !/^:$/.test(t.value) && !/^:$/.test(o().value) ? t.type === "Literal" ? (i.value.value = v(t.value), S(p(), n)) : (i.value.type = "Expression", j(t, n, i)) : w(p(), n, i)), j = (t, n, i) => (i.value.value += t.value, /^[({]$/.test(t.value) ? c.push(t.value) : /^[)}]$/.test(t.value) && c.pop(), /^[,}]$/.test(o().value) && c.length === 0 ? S(p(), n) : j(p(), n, i)), S = (t, n) => (n || (n = [], u.arguments.push({ type: "ObjectExpression", properties: n })), /^}$/.test(t.value) ? g(p()) : /^:$/.test(o().value) ? w(t, n) : S(p(), n)), b = (t, n) => (n || (n = [], u.arguments.push({ type: "ArrayExpression", elements: n })), /^]$/.test(t.value) ? g(p()) : (t.type === "Literal" && n.push({ type: "Literal", value: v(t.value) }), t.type === "Identifier" && n.push({ type: "Identifier", value: t.value }), b(p(), n))), g = (t) => Object.is(t, x()) ? u : t.type === "Literal" ? E(t) : t.type === "Identifier" && /^\($/.test(o().value) ? $(t) : t.type === "Identifier" ? P(t) : /^{$/.test(t.value) ? S(t) : /^\[$/.test(t.value) ? b(t) : g(p()), $ = (t, n, i = t.position.start) => n ? /^\)$/.test(t.value) ? (n.value = e.substring(i, t.position.end + 1), g(p())) : $(p(), n, i) : new RegExp(a).test(t.value) ? (u = {
    type: "CallExpression",
    value: e.substring(i, x().position.end + 1),
    arguments: []
  }, g(p())) : (n = { type: "CallExpression", value: "" }, u.arguments.push(n), $(p(), n, i));
  return $(s[f]);
}
function Z(s, e) {
  const a = new RegExp(`${e}\\(`, "gs"), u = [];
  let f;
  for (; (f = a.exec(s)) !== null; )
    u.push(f.index);
  return u;
}
function J(s, e) {
  const a = [], u = Z(s, e);
  for (const f of u) {
    const c = Q(s, f);
    if (c.length > 0)
      try {
        const o = W(c, s, e);
        o && a.push(o);
      } catch (o) {
        console.error(o), console.error(
          `
\x1B[31mQwik Speak Parser error\x1B[0m
%s`,
          s.substring(f, c[c.length - 1].position.end) + `
`
        );
      }
  }
  return a;
}
function _(s) {
  return /inlineTranslate/.test(s);
}
function G(s) {
  return /inlinePlural/.test(s);
}
function H(s) {
  let e = s.match(/(?<=\bconst\s).*?(?=\s?=\s?inlineTranslate\(\);?)/)?.[0]?.trim();
  return e ? (e.startsWith("$") || (e = `\\b${e}`), e = e.replace(/\$/g, "\\$"), e) : null;
}
function U(s) {
  let e = s.match(/(?<=\bconst\s).*?(?=\s?=\s?inlinePlural\(\);?)/)?.[0]?.trim();
  return e ? (e.startsWith("$") || (e = `\\b${e}`), e = e.replace(/\$/g, "\\$"), e) : null;
}
function X(s) {
  return JSON.parse(s, (e, a) => a === null ? void 0 : a);
}
function Y(s, e, a) {
  let u = 0;
  const f = e.length;
  for (; u < f; ) {
    const c = e[u++];
    s[c] = s[c] && !a ? s[c] : u === f ? a : typeof s[c] == "object" ? s[c] : {}, s = s[c];
  }
}
function N(s, e) {
  return typeof s == "object" && typeof e == "object" ? (Object.keys(e).map((a) => {
    s[a] = N(s[a], e[a]);
  }), s) : e;
}
function k(s, e) {
  typeof s == "object" && typeof e == "object" && Object.keys(e).forEach((a) => {
    typeof e[a] == "object" ? a in s ? k(s[a], e[a]) : Object.assign(s, { [a]: e[a] }) : !s[a] && e[a] && Object.assign(s, { [a]: e[a] });
  });
}
function ee(s) {
  return typeof s == "object" ? JSON.parse(JSON.stringify(s)) : s;
}
function te(s, e) {
  return s = { ...s, ...e }, s;
}
function se(s) {
  return JSON.stringify(s, ne, 2);
}
function R(s) {
  return Object.keys(s).sort().reduce(
    (e, a) => (typeof s[a] == "object" && !Array.isArray(s[a]) ? e[a] = R(s[a]) : e[a] = s[a], e),
    {}
  );
}
function ne(s, e) {
  return typeof e == "string" ? e.replace(/\\/g, "") : e;
}
function re(s, e) {
  const a = /* @__PURE__ */ new Set();
  for (let u = 0; u < 20; u++) {
    const f = new Intl.PluralRules(s, e).select(u);
    a.add(f);
  }
  return Array.from(a);
}
function ae(s) {
  let e;
  if (s) {
    e = {};
    for (const a of s)
      e = { ...e, [a.key.value]: a.value.value };
  }
  return e;
}
async function ue(s) {
  const e = {
    ...s,
    basePath: s.basePath ?? "./",
    sourceFilesPaths: s.sourceFilesPaths ?? ["src"],
    excludedPaths: s.excludedPaths ?? [],
    assetsPath: s.assetsPath ?? "i18n",
    format: s.format ?? "json",
    filename: s.filename ?? "app",
    fallback: s.fallback ?? ((t) => t),
    keySeparator: s.keySeparator ?? ".",
    keyValueSeparator: s.keyValueSeparator ?? "@@"
  }, a = /* @__PURE__ */ new Map(), u = e.sourceFilesPaths.map((t) => A(`${e.basePath}/${t}`)), f = e.excludedPaths.map((t) => A(`${e.basePath}/${t}`)), c = [];
  let o = Object.fromEntries(e.supportedLangs.map((t) => [t, {}]));
  const p = async (t, n) => {
    const i = await q(t, { withFileTypes: !0 });
    for (const d of i) {
      const y = K(t, d.name), r = F(d.name);
      d.isDirectory() ? n.includes(y) || await p(y, n) : /\.js|\.ts|\.jsx|\.tsx/.test(r) && !/test|spec/.test(d.name) && c.push(y);
    }
  }, x = (t) => t.type === "Identifier" || t.type === "Literal" && t.value && /\${.*}/.test(t.value) ? (a.set("dynamic", (a.get("dynamic") ?? 0) + 1), !0) : !1, v = async (t) => {
    const n = [];
    let i = await T(A(`${e.basePath}/${t}`), "utf8");
    const d = (r) => {
      i = i.replace(new RegExp(`${r}<.*>\\(`, "g"), `${r.replace("\\b", "")}(`);
    }, y = (r) => {
      for (const l of r) {
        const h = l.arguments;
        if (h?.length > 0) {
          if (h[0].type === "ArrayExpression") {
            if (h[0].elements) {
              for (const m of h[0].elements)
                if (m.type === "Literal") {
                  if (x(m))
                    continue;
                  n.push(m.value);
                }
            }
          } else if (h?.[0]?.value) {
            if (x(h[0]))
              continue;
            n.push(h[0].value);
          }
        }
      }
    };
    if (_(i)) {
      const r = H(i);
      if (r) {
        d(r);
        const l = J(i, r);
        y(l);
      }
    }
    if (G(i)) {
      const r = U(i);
      if (r) {
        const l = J(i, r);
        for (const h of l) {
          const m = h.arguments;
          if (m?.length > 0) {
            if (m[1]?.type === "Identifier" || m[1]?.type === "CallExpression" || m[3]?.type === "Identifier" || m[3]?.type === "CallExpression") {
              a.set("dynamic plural", (a.get("dynamic plural") ?? 0) + 1);
              continue;
            }
            const L = /* @__PURE__ */ new Set(), V = ae(m[3]?.properties);
            for (const O of e.supportedLangs) {
              const I = re(O, V);
              for (const z of I)
                L.add(z);
            }
            const B = m?.[1]?.value;
            if (B) {
              const O = {};
              for (const I of L)
                O[I] = "";
              n.push(`${B}${e.keyValueSeparator}${JSON.stringify(O)}`);
            } else
              for (const O of L)
                n.push(O);
          }
        }
      }
    }
    return n;
  }, E = async () => {
    const t = /* @__PURE__ */ new Map();
    for (const n of e.supportedLangs) {
      const i = A(`${e.basePath}/${e.assetsPath}/${n}`);
      if (C(i)) {
        const d = await q(i);
        if (d.length > 0) {
          const y = F(d[0]);
          let r = {};
          const l = d.map((m) => T(`${i}/${m}`, "utf8")), h = await Promise.all(l);
          for (const m of h)
            if (m) {
              let L = {};
              switch (y) {
                case ".json":
                  L = X(m);
                  break;
              }
              r = te(r, L);
            }
          t.set(n, r);
        }
      }
    }
    return t;
  }, P = async (t) => {
    for (const n of e.supportedLangs) {
      const i = A(`${e.basePath}/${e.assetsPath}/${n}`);
      C(i) || D(i, { recursive: !0 });
      const d = Object.keys(o[n]).filter((l) => !t.includes(l)), y = Object.keys(o[n]).filter((l) => t.includes(l)), r = {};
      o[n][e.filename] && (r[e.filename] = o[n][e.filename]);
      for (const l of y)
        r[l] = o[n][l];
      Object.keys(r).length > 0 && await w(r, e.filename, i);
      for (const l of d.filter((h) => h !== e.filename))
        await w({ [l]: o[n][l] }, l, i);
    }
  }, w = async (t, n, i) => {
    let d;
    switch (e.format) {
      case "json":
        d = se(t);
        break;
    }
    const y = A(`${i}/${n}.${e.format}`);
    await M(y, d), console.log(y);
  };
  for (const t of u)
    await p(t, f);
  const j = c.map((t) => v(t)), S = await Promise.all(j);
  let b = [];
  for (const t of S)
    b = b.concat(t);
  b = [...new Set(b)], a.set("unique keys", (a.get("unique keys") ?? 0) + b.length);
  const g = [];
  for (let t of b) {
    let n;
    [t, n] = t.split(e.keyValueSeparator), /^[[{].*[\]}]$/.test(n) && !/^{{/.test(n) && (n = JSON.parse(n));
    for (const i of e.supportedLangs)
      Y(o[i], t.split(e.keySeparator), ee(n || ""));
    g.push(t);
  }
  const $ = await E();
  if ($.size > 0)
    for (const [t, n] of $)
      N(o[t], n);
  for (const t of e.supportedLangs)
    o[t] = R(o[t]);
  o = e.fallback(o), await P(g);
  for (const [t, n] of a)
    switch (t) {
      case "unique keys":
        console.log("\x1B[32m%s\x1B[0m", `extracted keys: ${n}`);
        break;
      case "dynamic":
        console.log("\x1B[32m%s\x1B[0m", `translations skipped due to dynamic keys: ${n}`);
        break;
      case "dynamic plural":
        console.log("\x1B[32m%s\x1B[0m", `plurals skipped due to dynamic keys/options: ${n}`);
        break;
    }
}
export {
  k as deepMergeMissing,
  ue as qwikSpeakExtract
};
