import { readdir as Q, readFile as W, writeFile as _ } from "fs/promises";
import { existsSync as F, createWriteStream as z, mkdirSync as G } from "fs";
import { normalize as E, extname as K } from "path";
/**
 * @license
 * Qwik Speak
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/robisim74/qwik-speak/blob/main/LICENSE
 */
function Z(e, t = 0) {
  const n = [], r = [], a = [];
  let u = "", l = t;
  const f = (c) => (t = l, { type: c, value: $(), position: { start: t, end: l } }), s = (c) => {
    c.value = $(), c.position.start = t, c.position.end = l;
  }, i = () => e[++l], p = () => l < e.length - 1 ? e[l + 1] : "", m = () => l > 0 ? e[l - 1] : "", $ = () => e.substring(t, l + 1), d = (c) => /["'`0-9+-]/.test(c), P = (c) => /[a-zA-Z_$]/.test(c), x = (c) => /[(){},:;.[\]?!=<>]/.test(c), b = (c) => /\//.test(c) && /\*/.test(p()), I = (c, h) => {
    if (!h)
      h = f("Literal"), n.push(h);
    else {
      if (a.length === 0 && !/[0-9.]/.test(c))
        return S(c);
      s(h);
    }
    return a.length === 0 && /["'`]/.test(c) ? a.push(c) : a.length > 0 && a[a.length - 1] === c && (/\\/.test(m()) || a.pop()), I(i(), h);
  }, o = (c, h) => {
    if (!h)
      u = c, h = f("Identifier"), n.push(h);
    else if (/[0-9a-zA-Z_$. ]/.test(c))
      u += c, (u == "null" || u == "undefined" || u == "true" || u == "false" || u == "void 0") && (h.type = "Literal"), s(h);
    else
      return S(c);
    return o(i(), h);
  }, y = (c, h) => (h = f("Punctuator"), n.push(h), /\(/.test(c) ? r.push(c) : /\)/.test(c) && r.pop(), S(i())), g = (c) => /\//.test(c) && /\*/.test(m()) ? S(c) : g(i()), J = () => n[n.length - 1]?.type === "Punctuator" && r.length === 0 || l === e.length, S = (c = e[l]) => J() ? n : d(c) ? I(c) : P(c) ? o(c) : x(c) ? y(c) : b(c) ? g(c) : S(i());
  return S();
}
function H(e, t, n) {
  let r, a = 0;
  const u = [], l = () => a < e.length - 1 ? e[a + 1] : { type: "", value: "", position: { start: 0, end: 0 } }, f = () => e[++a], s = () => e[e.length - 1], i = (o) => o.replace(/^["'`]|["'`]$/g, ""), p = (o) => (r.arguments.push({ type: "Literal", value: i(o.value) }), b(f())), m = (o) => (r.arguments.push({ type: "Identifier", value: o.value }), b(f())), $ = (o, y, g) => (g || (g = {
    type: "Property",
    key: { type: "Identifier", value: o.value },
    value: { type: "Literal", value: "" }
  }, y.push(g)), !/^:$/.test(o.value) && !/^:$/.test(l().value) ? o.type === "Literal" ? (g.value.value = i(o.value), P(f(), y)) : (g.value.type = "Expression", d(o, y, g)) : $(f(), y, g)), d = (o, y, g) => (g.value.value += o.value, /^[({]$/.test(o.value) ? u.push(o.value) : /^[)}]$/.test(o.value) && u.pop(), /^[,}]$/.test(l().value) && u.length === 0 ? P(f(), y) : d(f(), y, g)), P = (o, y) => (y || (y = [], r.arguments.push({ type: "ObjectExpression", properties: y })), /^}$/.test(o.value) ? b(f()) : /^:$/.test(l().value) ? $(o, y) : P(f(), y)), x = (o, y) => (y || (y = [], r.arguments.push({ type: "ArrayExpression", elements: y })), /^]$/.test(o.value) ? b(f()) : (o.type === "Literal" && y.push({ type: "Literal", value: i(o.value) }), o.type === "Identifier" && y.push({ type: "Identifier", value: o.value }), x(f(), y))), b = (o) => Object.is(o, s()) ? r : o.type === "Literal" ? p(o) : o.type === "Identifier" && /^\($/.test(l().value) ? I(o) : o.type === "Identifier" ? m(o) : /^{$/.test(o.value) ? P(o) : /^\[$/.test(o.value) ? x(o) : b(f()), I = (o, y, g = o.position.start) => y ? /^\)$/.test(o.value) ? (y.value = t.substring(g, o.position.end + 1), b(f())) : I(f(), y, g) : new RegExp(n).test(o.value) ? (r = {
    type: "CallExpression",
    value: t.substring(g, s().position.end + 1),
    arguments: []
  }, b(f())) : (y = { type: "CallExpression", value: "" }, r.arguments.push(y), I(f(), y, g));
  return I(e[a]);
}
function U(e, t) {
  const n = new RegExp(`${t}\\(`, "gs"), r = [];
  let a;
  for (; (a = n.exec(e)) !== null; )
    r.push(a.index);
  return r;
}
function B(e, t) {
  const n = [], r = U(e, t);
  for (const a of r) {
    const u = Z(e, a);
    if (u.length > 0)
      try {
        const l = H(u, e, t);
        l && n.push(l);
      } catch (l) {
        console.error(l), console.error(
          `
\x1B[31mQwik Speak Parser error\x1B[0m
%s`,
          e.substring(a, u[u.length - 1].position.end) + `
`
        );
      }
  }
  return n;
}
function X(e) {
  return /inlineTranslate/.test(e);
}
function Y(e) {
  return /inlinePlural/.test(e);
}
function ee(e) {
  let t = e.match(/(?<=\bconst\s).*?(?=\s?=\s?inlineTranslate\(\);?)/)?.[0]?.trim();
  return t ? (t.startsWith("$") || (t = `\\b${t}`), t = t.replace(/\$/g, "\\$"), t) : null;
}
function te(e) {
  let t = e.match(/(?<=\bconst\s).*?(?=\s?=\s?inlinePlural\(\);?)/)?.[0]?.trim();
  return t ? (t.startsWith("$") || (t = `\\b${t}`), t = t.replace(/\$/g, "\\$"), t) : null;
}
function ne(e) {
  return JSON.parse(e, (t, n) => n === null ? void 0 : n);
}
function se(e, t) {
  const n = /* @__PURE__ */ new Set();
  for (let r = 0; r < 20; r++) {
    const a = new Intl.PluralRules(e, t).select(r);
    n.add(a);
  }
  return Array.from(n);
}
function re(e) {
  let t;
  if (e) {
    t = {};
    for (const n of e)
      t = { ...t, [n.key.value]: n.value.value };
  }
  return t;
}
function ie(e, t) {
  return e = { ...e, ...t }, e;
}
const j = "__qsInlineTranslate", q = "__qsInlinePlural", k = [], T = [], le = (e, t) => `${e} - ${t}`, ae = (e, t) => `dynamic ${t}: ${e}`;
let w, A, L;
function qe(e) {
  let t = "";
  const n = async (s) => {
    const i = E(`${t}/${s}`);
    let p = {};
    if (F(i)) {
      const m = await Q(i);
      if (m.length > 0) {
        const $ = K(m[0]), d = m.map((x) => W(`${i}/${x}`, "utf8")), P = await Promise.all(d);
        for (const x of P)
          if (x) {
            let b = {};
            switch ($) {
              case ".json":
                b = ne(x);
                break;
            }
            p = ie(p, b);
          }
      }
    }
    return p;
  }, r = {
    ...e,
    basePath: e.basePath ?? "./",
    assetsPath: e.assetsPath ?? "i18n",
    loadAssets: e.loadAssets ?? n,
    outDir: e.outDir ?? "dist",
    keySeparator: e.keySeparator ?? ".",
    keyValueSeparator: e.keyValueSeparator ?? "@@"
  };
  t = `${r.basePath}/${r.assetsPath}`;
  const a = Object.fromEntries(r.supportedLangs.map((s) => [s, {}]));
  let u;
  const l = /* @__PURE__ */ new Set();
  return {
    name: "vite-plugin-qwik-speak-inline",
    enforce: "post",
    apply: void 0,
    // both
    configResolved(s) {
      s.build?.ssr || s.mode === "ssr" ? w = "ssr" : s.mode === "lib" ? w = "lib" : s.mode === "test" ? w = "test" : w = "client", A = s.isProduction || s.mode === "production" ? "prod" : "dev";
      const i = s.build?.rollupOptions?.input;
      i && (Array.isArray(i) ? L = i[0] : typeof i == "string" && (L = i)), L = L?.split("/")?.pop();
    },
    configureServer(s) {
      A === "dev" && s.ws.on("qwik-speak:lang", (i) => {
        if (u && u !== i.msg) {
          for (const p of l) {
            const m = s.moduleGraph.getModuleById(p);
            m && s.moduleGraph.invalidateModule(m);
          }
          l.clear();
        }
        u = i.msg;
      });
    },
    handleHotUpdate({ file: s, server: i }) {
      if (new RegExp(r.assetsPath).test(s) && /\.(json)$/.test(s)) {
        for (const p of r.supportedLangs)
          new RegExp(p).test(s) && n(p);
        for (const p of l) {
          const m = i.moduleGraph.getModuleById(p);
          m && i.moduleGraph.invalidateModule(m);
        }
        l.clear();
      }
    },
    /**
     * Load translation files when build starts
     */
    async buildStart() {
      (w === "client" || A === "dev") && await Promise.all(r.supportedLangs.map(async (s) => {
        const i = await r.loadAssets(s);
        Object.assign(a[s], i);
      }));
    },
    /**
     * Transform functions
     * Prefer transform hook because unused imports will be removed, unlike renderChunk
     */
    async transform(s, i, p) {
      if ((w === "client" || w === "ssr" && p?.ssr === !1) && /\/src\//.test(i) && /\.(js|cjs|mjs|jsx|ts|tsx)$/.test(i))
        return Y(s) && (s = fe(s)), X(s) && (s = oe(s)), A === "dev" && (s.includes(j) || s.includes(q)) && (s = M(s, u, r, a), l.add(i)), s;
      w === "ssr" && (i.endsWith("entry.ssr.tsx") || i.endsWith("entry.ssr.jsx")) && (/(?<!\/\/\s*)base:\s*extractBase/.test(s) || (console.log(
        `
\x1B[31mQwik Speak Inline error\x1B[0m
%s`,
        "Missing 'base' option in 'entry.ssr.tsx' file: see https://robisim74.gitbook.io/qwik-speak/tools/setup"
      ), process.exit(1)));
    },
    /**
     * Split chunks by lang
     */
    async writeBundle(s, i) {
      if (w === "client") {
        const p = s.dir ? s.dir : E(`${r.basePath}/${r.outDir}`), m = Object.values(i), $ = r.supportedLangs.map((d) => ue(d, m, p, a, r));
        await Promise.all($);
      }
    },
    async closeBundle() {
      if (w === "client") {
        const s = z("./qwik-speak-inline.log", { flags: "w" });
        s.write(`${w}: ` + (L ?? "-") + `
`), s.write(`
Missing value for keys:
`), k.forEach((i) => s.write(i + `
`)), s.write(`
Make sure the keys are in 'runtimeAssets':
`), T.forEach((i) => s.write(i + `
`)), s.write(`
Qwik Speak Inline: build ends at ${(/* @__PURE__ */ new Date()).toLocaleString()}
`), (k.length > 0 || T.length > 0) && console.log(
          `
\x1B[33mQwik Speak Inline warn\x1B[0m
%s`,
          "There are missing values or dynamic keys: see ./qwik-speak-inline.log"
        );
      }
    }
  };
}
async function ue(e, t, n, r, a) {
  const u = E(`${n}/build/${e}`);
  F(u) || G(u, { recursive: !0 });
  for (const l of t) {
    const f = [];
    if (l.type === "chunk" && "code" in l && /build\//.test(l.fileName)) {
      const s = E(`${u}/${l.fileName.split("/")[1]}`);
      let i = l.code;
      if (i = M(i, e, a, r), f.push(_(s, i)), e === a.defaultLang) {
        const p = E(`${n}/build`), m = E(`${p}/${l.fileName.split("/")[1]}`);
        f.push(_(m, i));
      }
    }
    await Promise.all(f);
  }
}
function oe(e) {
  const t = ee(e);
  if (!t)
    return e;
  let n = !1;
  const r = B(e, t);
  if (r.length === 0)
    return e;
  for (const a of r) {
    const u = a.value, l = a.arguments;
    if (l?.length > 0) {
      if (de(l, u)) {
        n = !0;
        continue;
      }
      const f = u.replace(new RegExp(`${t}\\(`), `${j}(`);
      e = e.replace(u, f);
    }
  }
  return n || (e = Se(e, t)), e;
}
function fe(e) {
  const t = te(e);
  if (!t)
    return e;
  let n = !1;
  const r = B(e, t);
  if (r.length === 0)
    return e;
  for (const a of r) {
    const u = a.value, l = a.arguments;
    if (l?.length > 0) {
      if ($e(l, u)) {
        n = !0;
        continue;
      }
      const f = u.replace(new RegExp(`${t}\\(`), `${q}(`);
      e = e.replace(u, f);
    }
  }
  return n || (e = Ee(e, t)), e;
}
function M(e, t, n, r) {
  return e.includes(q) && (e = pe(e, q, j, t, n)), e.includes(j) && (e = ce(e, r, j, t, n)), e;
}
function ce(e, t, n, r, a) {
  const u = B(e, n);
  if (u.length === 0)
    return e;
  for (const l of u) {
    const f = l.value, s = l.arguments;
    if (s?.length > 0) {
      const i = N(r, s[2], a);
      let p = v("");
      if (s[0].type === "ArrayExpression") {
        const $ = he(s[0]), d = [];
        for (const P of $) {
          const x = D(
            P,
            t[i],
            s[1],
            a.keySeparator,
            a.keyValueSeparator,
            i
          );
          d.push(x);
        }
        p = d;
      } else if (s?.[0]?.value) {
        const $ = ge(s[0]);
        p = D(
          $,
          t[i],
          s[1],
          a.keySeparator,
          a.keyValueSeparator,
          i
        );
      }
      const m = ye(p);
      e = e.replace(f, m);
    }
  }
  return e;
}
function pe(e, t, n, r, a) {
  const u = B(e, t);
  if (u.length === 0)
    return e;
  for (const l of u) {
    const f = l.value, s = l.arguments;
    if (s?.length > 0) {
      const i = N(r, s[4], a), p = re(s[3]?.properties), m = se(i, p), $ = me(m, i, n, s, a);
      e = e.replace(f, $);
    }
  }
  return e;
}
function ye(e) {
  return typeof e == "object" ? `${be(e)}` : e;
}
function me(e, t, n, r, a) {
  let u = "";
  return u += ((f) => {
    let s = "(";
    for (const i of e) {
      let p = r[1]?.value;
      p = p ? `${p}${a.keySeparator}${i}` : i;
      const m = [{
        type: "Property",
        key: { type: "Identifier", value: "value" },
        value: { type: "Expression", value: r[0].value }
      }];
      if (r[2]?.properties)
        for (const d of r[2].properties)
          m.push(d);
      const $ = m.map((d) => `${d.key.value}: ${C(d)}`).join(", ");
      if (i !== e[e.length - 1]) {
        const d = r[3]?.properties?.map((x) => `${x.key.value}: ${C(x)}`)?.join(", "), P = Pe(f, r[0].value, i, d);
        s += P + ` && ${n}(${v(p)}, {${$}}, ${v(f)}) || `;
      } else
        s += `${n}(${v(p)}, {${$}}, ${v(f)})`;
    }
    return s += ")", s;
  })(t), u;
}
function de(e, t) {
  if (e?.[0]?.value) {
    if (e[0].type === "Identifier" || e[0].type === "Literal" && /\${.*}/.test(e[0].value))
      return O(t, "key"), !0;
    if (e[1]?.type === "Identifier" || e[1]?.type === "CallExpression" || e[2]?.type === "Identifier" || e[2]?.type === "CallExpression")
      return O(t, "params"), !0;
  }
  return !1;
}
function $e(e, t) {
  return e?.[0]?.value && (e[1]?.type === "Identifier" || e[1]?.type === "CallExpression" || e[2]?.type === "Identifier" || e[2]?.type === "CallExpression" || e[3]?.type === "Identifier" || e[3]?.type === "CallExpression" || e[4]?.type === "Identifier" || e[4]?.type === "CallExpression") ? (O(t, "params"), !0) : !1;
}
function N(e, t, n) {
  let r;
  return t?.type === "Literal" && (r = n.supportedLangs.find((a) => a === t.value)), r ?? e;
}
function ge(e) {
  return e.value;
}
function he(e) {
  const t = [];
  if (e.elements)
    for (const n of e.elements)
      n.type === "Literal" && t.push(n.value);
  return t;
}
const ve = (e, t) => e.split(t);
function D(e, t, n, r, a, u) {
  let l;
  [e, l] = ve(e, a);
  const f = e.split(r).reduce((s, i) => s && s[i] !== void 0 ? s[i] : void 0, t);
  if (f) {
    if (typeof f == "string")
      return n ? V(f, n) : v(f);
    if (typeof f == "object")
      return n ? R(f, n) : f;
  } else
    u && we(u, e);
  return l ? !/^[[{].*[\]}]$/.test(l) || /^{{/.test(l) ? n ? V(l, n) : v(l) : n ? R(JSON.parse(l), n) : JSON.parse(l) : v(A === "dev" ? e : "");
}
function R(e, t) {
  return Object.keys(e).map((n) => {
    typeof e[n] == "string" && (e[n] = t ? V(e[n], t) : v(e[n])), e[n] && typeof e[n] == "object" && (e[n] = R(e[n], t));
  }), e;
}
function V(e, t) {
  if (t.properties)
    for (const n of t.properties)
      e = e.replace(/{{\s?([^{}\s]*)\s?}}/g, (r, a) => a === n.key.value ? xe(n) : r);
  return v(e);
}
function v(e) {
  return /^`.*`$/.test(e) ? e : "`" + e + "`";
}
function xe(e) {
  return e.value.type === "Literal" ? e.value.value : "${" + e.value.value + "}";
}
function C(e) {
  return e.value.type === "Literal" ? v(e.value.value) : e.value.value;
}
function Pe(e, t, n, r) {
  return r ? `new Intl.PluralRules(${v(e)}, {${r}}).select(+${t}) === ${v(n)}` : `new Intl.PluralRules(${v(e)}).select(+${t}) === ${v(n)}`;
}
function be(e) {
  let t = JSON.stringify(e, Le);
  return t = t.replace(/("__qsOpenBt)|(__qsCloseBt")/g, "`"), t;
}
function we(e, t) {
  const n = le(e, t);
  k.includes(n) || k.push(n);
}
function O(e, t) {
  const n = ae(Ie(e), t);
  T.includes(n) || T.push(n);
}
function Ie(e) {
  return e.replace(/\s+/g, " ").trim();
}
function Se(e, t) {
  return e.replace(new RegExp(`\\bconst\\s${t}\\s=\\sinlineTranslate\\(\\);?`, "g"), "");
}
function Ee(e, t) {
  return e.replace(new RegExp(`\\bconst\\s${t}\\s=\\sinlinePlural\\(\\);?`, "g"), "");
}
function Le(e, t) {
  return typeof t == "string" && /^`.*`$/.test(t) ? t.replace(/^`/, "__qsOpenBt").replace(/`$/, "__qsCloseBt") : t;
}
function ke(e, t) {
  return t !== "production" ? e : e.map((r) => ({
    prefix: r.domain ? void 0 : r.prefix,
    paths: r.paths,
    lang: r.prefix,
    domain: r.domain,
    withDomain: r.withDomain
  }));
}
export {
  qe as qwikSpeakInline,
  ke as toPrefixAsNeeded
};
